Description

My colleagues have starting re-arranging their issue lists now that we have subtasks and every single one of them has asked how

they can change the issue listing to make it obvious at a glance which subtasks belong to which issue.

Having this ability is a critical feature I think to make subtasks manageable.

Something like:

Put all subtasks under their parent tasks in the issue listing.

add a - or > in the issue title as basic indentation.

I imagine this won't be a simple change because it will affect how the table ordering code should work.

Related issues:

Related to Redmine - Feature #5325: Add Parent Task to 'Group Results By' dro... New 2010-04-15

Related to Redmine - Feature #6118: Filter by parent task or subtasks Closed 2010-08-12

Related to Redmine - Feature #7907: Display Issues in a hierarchy (tree) New 2011-03-17

Has duplicate Redmine - Feature #6816: Group Parent task with  subtask  under... Closed 2010-11-03

Has duplicate Redmine - Feature #7696: Allow grouping by parent task Closed 2011-02-23

History

#1 - 2010-08-12 07:06 - Jeffrey Jones

Actually looking at it, probably the easiest thing to do would be to use the group by functionality already in the system to group the subtasks

#2 - 2010-08-12 07:37 - Xagyg Wulf

Add "Parent Task" column to the issues list. Sort on parent task column. An arrow is placed for subtasks of a parent and grouped under it.

#3 - 2010-08-13 02:21 - Jeffrey Jones

Aha, that is perfect, just what I want. Apart from the fact that we have to have the parent task column visible which takes up a lot of space we would

rather use for other stuff.

A way to get this exact layout without having to have the parent task column visible would be perfect.

#4 - 2010-08-13 04:31 - Mischa The Evil

- Category changed from Issues to UI

#5 - 2010-08-17 01:24 - Alex Last

there's related task #5275

#6 - 2010-11-03 07:24 - Nicolas Connault

Jeffrey Lee

What you are trying to do is possible in Redmine 1.0.3. You need to create a custom query that sorts by parent task without adding the parent task

column to the list. Here's how to do it:

Above the issues list, there should be 3 buttons: Apply, Clear and Save. These buttons refer to the filters and other options above them. When you

click on save, it takes you to the New Query page.
https://www.redmine.org/issues/5275
https://www.redmine.org/users/82765


*Name your query (e.g. Sort by Parent Task)

*Tick Public, All projects and Default columns

*Select "Parent Task" in the first drop-down under the "Sort" section, then "Ascending" in the next drop-down to the right

*Add any other sorts or filters (sorting by Priority and/or date submitted is probably useful)

*Click Save

Now this query will be the default view for all issue lists, and hopefully for all users (I haven't tried logging as a different user).

#7 - 2010-11-03 07:27 - Nicolas Connault

Update: the custom query is available to all users, but is not selected by default. Also, I don't know how to edit or delete a custom query once it has

been created. I'm sure it's possible.

#8 - 2011-05-17 11:37 - Tomasz Sawicki

In order to sort by parent task and task id by default (which makes the subtask tree appear) in app/controllers/issues_controller.rb find index method

and change

sort_init(@query.sort_criteria.empty? ? [['id', 'desc']] : @query.sort_criteria)

to

sort_init(@query.sort_criteria.empty? ? [['root_id', 'desc'], ['id', 'desc']] : @query.sort_criteria)

#9 - 2011-05-17 18:11 - Tomasz Sawicki

- File issues_default_sort_by_root_id_and_id-1.3.1.patch added

Attached patch for 1.3.1 adding root_id desc to default sort order.

#10 - 2011-07-20 16:00 - arthur me

Patch applies correctly for me. This is an extremely handy feature.

#11 - 2011-07-21 01:02 - Lukas Elmer

+1

arthur me wrote:

Patch applies correctly for me. This is an extremely handy feature.

#12 - 2011-08-18 10:49 - Steffen Tischer

Thanks for that path. It is very useful.

But i have one question: If i set another sort column i can not reset this settings to default sort order.

In my opinion it is useful to reset also the sort setting if i click on "Reset" on top of the list. This button clears all setting except the sort settings.

Is this possible?

#13 - 2011-11-21 04:41 - Mischa The Evil

Isn't this issue a duplicate of #5325?

#14 - 2017-02-26 20:22 - Stefan Lindner

+1

#15 - 2021-05-21 10:04 - Marco Shima

Mischa The Evil wrote:

Isn't this issue a duplicate of #5325?

 No, it's not. This issue is about sorting tickets, #5325 is about grouping tickets.

#16 - 2022-01-07 04:31 - Jim Jiminson

Tomasz Sawicki wrote:

Attached patch for 1.3.1 adding root_id desc to default sort order.
 Is there an easy way to do this for other sorting? Sorting by root_id first seems to invalidate/break secondary sorts.

#17 - 2025-02-10 14:09 - Veit Jahns

Xagyg Wulf wrote in #note-2:

Add "Parent Task" column to the issues list. Sort on parent task column. An arrow is placed for subtasks of a parent and grouped under it.

 Works for me as well. But any improvement is much appreciated.

Files

issues_default_sort_by_root_id_and_id-1.3.1.patch 542 Bytes 2011-05-17 Tomasz Sawicki
